
from constants import *
import numpy as np


def update_status_one_flight(ts_min,ts_max,te_max,t_start,t_end,flight):
    if te_max < t_start:  # completed
        flight.status = 3
    elif (ts_min < t_start) and (te_max >= t_start):  # on going
        flight.status = 2
    elif ts_min >= t_start and ts_max < t_end:  # active
        flight.status = 1
    else:  # planned
        flight.status = 0


def set_status_flights(flightset,airport, t_start,t_end):
    for id in flightset.flights_a:
        flight = flightset.flights_a[id]
        ts_min = flight.landing_time - DELTA_L_MIN
        ts_max = flight.landing_time + DELTA_L_MAX
        te_max = int(ts_max + max(airport.taxi_in_duration[:,flight.terminal]))
        update_status_one_flight(ts_min,ts_max,te_max,t_start,t_end,flight)
    # for id in flightset.id_flights_only_d:
    for id in flightset.flights_d:
        flight = flightset.flights_d[id]
        ts_min = flight.obt
        ts_max = flight.obt + DELTA_OBT
        te_max = int(ts_max + max(airport.taxi_out_duration[flight.terminal,:]))
        update_status_one_flight(ts_min,ts_max,te_max,t_start,t_end,flight)


def compute_terminals_occupancy(flightset, apt):
    count = np.zeros(len(apt.terminals))
    for flight in flightset.flights_a.values():
        if flight.status == 3:
            count[flight.terminal] += 1
    for flight in flightset.flights_d.values():
        if flight.status == 3:
            count[flight.terminal] -=1
    for i in range(len(count)):
        apt.terminals[i].initial_occupancy = apt.terminals[i].nb_initial_departures + count[i]
    return apt


